Subject: Re: [MEDIACTRL] ivr-control-package-05: <params> in <dialogprepare>

From: "McGlashan, Scott" <[email-masked]>
Date: Mon, 2 Mar 2009 18:00:32 +0000

Hi Stephane,

Ok, I can see a potential use case. In vxml, you could prefetch a resource which uses an expr to set the location and that expr could use parameter information set in a <dialogprepare>. I've added <params> to <dialogprepare> and updated the language in the vxml appendix to deal with it in version -06.

thanks

Scott

________________________________
From: Stéphane Bastien [mailto:[email-masked]]
Sent: Thursday, February 26, 2009 15:46
To: McGlashan, Scott; [email-masked]
Subject: RE: ivr-control-package-05: <params> in <dialogprepare>

Hi,

I'm looking at CCXML's <dialogprepare> and I find that <parameters> is present. I'm just wondering why this functionality is dropped from ivr-control-package.

In my mind, preparing a VoiceXML dialog means:
1. Downloading the script from the web server
2. Setting up the script's session variables as much as possible, including parameters (only connection session variables can't be setup upfront)
3. Downloading any documents/media files referred to by the script

The goal is that when <dialogstart> is issued, processing starts right away. Now, I agree that we could postpone setting up the parameters until <dialogstart> is issued. But why enforce this behavior in the protocol?

Stephane

From: McGlashan, Scott [mailto:[email-masked]]
Sent: 26 février 2009 09:31
To: Stéphane Bastien; [email-masked]
Subject: RE: ivr-control-package-05: <params> in <dialogprepare>

Hi Stephane,

We added <params> in <dialogstart> so parameter setting could be done as late as possible, when you set other information, such as the connection, on the dialog. That is the use case we commonly see - prepare a dialog and when the AS connects the call, then set caller information (e.g. subscriber id, etc) allowing execution of the dialog to be customized for the caller.

It would be possible to add <params> to <dialogprepare> as well as <dialogstart>. We'd need to detail in our VoiceXML appendix how <params> are treated when specified in both.

However, I'm not clear of the value of adding them to <dialogprepare> as well.  Do you have a use case in mind which cannot be handled by the current approach?

thanks

scott

________________________________
From: [email-masked] [mailto:[email-masked]] On Behalf Of Stéphane Bastien
Sent: Wednesday, February 25, 2009 23:49
To: [email-masked]
Subject: [MEDIACTRL] ivr-control-package-05: <params> in <dialogprepare>
Hi,

Why is the <params> element allowed in <dialogstart> but not in <dialogprepare> ?

For example, why is this not allowed?

   <mscivr version="1.0" xmlns="urn:ietf:params:xml:ns:msc-ivr">
    <dialogprepare dialogid="d2" type="application/voicexml+xml"
                   src="http://www.example.com/mydialog.vxml"
                   fetchtimeout="15s">
     <params>
      <param name="prompt1">nfs://nas01/media1.3gp</param>
      <param name="prompt2">nfs://nas01/media2.3gp</param>
     </params>
    </dialogprepare>
   </mscivr>

Thanks,

Stéphane